<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<!--
vim:tw=78
-->
<html lang="en">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
        <title>EtherLab :: Process Data Simulation</title>
        <link rel="stylesheet" href="docstyle.css" type="text/css"/>
        <meta name="generator" content="DocBook XSL Stylesheets V1.52.2"/>
        <meta http-equiv="Content-Script-Type" content="text/javascript"/>
        <meta name="toctype" content="ug"/>
        <script language="JavaScript" src="docscripts.js"></script>
    </head>
    <body>
        <a name="top_of_page"></a>
        <p style="font-size:1px;">&nbsp;</p>
        <h2>Simulate Process Data by swapping Inputs and Outputs</h2>

        <p>EtherLab, since version 2.4.0, can also be used to simulate the
        Process Data of EtherCAT Slaves,
        which is useful to build a simulator for an control application.
        The control application does not need to be modified,
        because the same interface as the EtherCAT master is used.</p>

        <p>The simulator application uses the same EtherCAT blocks as the
        control application, but with their Inputs and Outputs swapped.
        So a block representing an Digital Output actually has a Simulink Output
        which will be controlled by the control application.
        To swap the ports, please check the <q>Swap Inputs and Outputs of EtherCAT
        blocks for simulating Process Data with libfakeethercat</q> Option
        in <q>EtherLab C code generation options</q> section of your simulator
        model configuration (Ctrl+E).
        </p>

        <p>Both applications use libfakeethercat to exchange the Process Data.
        This library has a subset of the libethercat API,
        but uses <a href="https://gitlab.com/etherlab.org/rtipc">RtIPC</a>
        to communicate between both applications.
        Please refer to the
        <a href="https://docs.etherlab.org/ethercat/1.6/doxygen/libfakeethercat.html">
        EtherCAT Documentation</a> to learn about how to set up libfakeethercat.
        </p>

    </body>
</html>
